Page MenuHomePhabricator

Use the "Timeless" skin by default on frwiktionary
Closed, DeclinedPublic

Description

A voting is ongoing on the French Wiktionary in order to apply the "Timeless" skin by default on the French Wiktionary. The voting will end on March 20th.
I will inform you once it will be over in order to apply the change.
Ideally, it would be nice if the skin is available on March, 22nd 2019 corresponding to the 15th anniversary of the French Wiktionary.

Event Timeline

Pamputt created this task.Mar 8 2019, 10:11 AM

What does "default" mean? Logged-in users? Anonymous users? New logged-in users?

Also note that changes of this kind are not generally allowed.

For the records:

Currently the settings for Wikimedia sites on https://noc.wikimedia.org/conf/InitialiseSettings.php.txt say:

'wgDefaultSkin' => [
	'default' => 'vector',
	'nostalgiawiki' => 'nostalgia',
],

A similar request in the past at https://phabricator.wikimedia.org/T26527#279612 got declined (but is not listed on https://meta.wikimedia.org/wiki/Limits_to_configuration_changes it seems).

A similar request in the past at https://phabricator.wikimedia.org/T26527#279612 got declined

It looks like there are some pretty crucial differences to me.

What does "default" mean? Logged-in users? Anonymous users? New logged-in users?

It means for everyone except logged-in user that have changed the skin in their preference.

Also note that changes of this kind are not generally allowed.

+1, Skin Vector is the Base identity of Wikipedia and its sister projects.

Isarra added a subscriber: Isarra.Mar 8 2019, 5:17 PM

I've just been avoiding this entire thing because it scares me (sorry), but if we do such a change, we do probably want to do it across all (normal) projects, and have a consensus that it's time to change the overall identity of the lot, since visual identity is a huge thing.

Even if the concerns are largely functional (such as that Vector just doesn't serve the needs of a project), it would still need to be across the entire project (all languages) to make sense, and even then probably require some wider... establishing that this is a thing we now do these days. Though I suppose if all languages of a project agreed it was needed, maybe that would be enough to get all the meta people on board... but we'd have to see it happen to really be sure. It'd at very least establish that we definitely need *some* sort of change, though.

It means for everyone except logged-in user that have changed the skin in their preference.

@Pamputt: What does "changed the skin in their preference" mean exactly? Do you propose to overwrite the skin setting of every account that has set "Vector" as their skin on https://fr.wiktionary.org/wiki/Spécial:Préférences#mw-prefsection-rendering ? Wouldn't that mean that a lot of people would log in and suddenly see a completely different user interface without knowing why and not necessarily knowing how to revert (if they wanted), even those people who intentionally chose to prefer Vector over other skins? (Note that the Preferences unfortunately does not offer a "Use default skin" setting; you explicitly have to choose a skin...)

Krenair added a comment.EditedMar 8 2019, 5:21 PM

Also note that changes of this kind are not generally allowed.

+1, Skin Vector is the Base identity of Wikipedia and its sister projects.

The Vector skin is used by all MediaWiki installations by default. Not sure I'd say it's the base identity of Wiktionary/Wikipedia, but I can understand concerns about it being different between different language wikis of the same project to some extent.

It means for everyone except logged-in user that have changed the skin in their preference.

@Pamputt: What does "changed the skin in their preference" mean exactly? Do you propose to overwrite the skin setting of every account that has set "Vector" as their skin on https://fr.wiktionary.org/wiki/Spécial:Préférences#mw-prefsection-rendering ? Wouldn't that mean that a lot of people would log in and suddenly see a completely different user interface without knowing why and not necessarily knowing how to revert (if they wanted), even those people who intentionally chose to prefer Vector over other skins? (Note that the Preferences unfortunately does not offer a "Use default skin" setting; you explicitly have to choose a skin...)

Pretty sure they're saying that everyone who hasn't selected a particular skin in preferences already would now get timeless, just they'd be able to change by going to preferences.

It means for everyone except logged-in user that have changed the skin in their preference.

@Pamputt: What does "changed the skin in their preference" mean exactly? Do you propose to overwrite the skin setting of every account that has set "Vector" as their skin on https://fr.wiktionary.org/wiki/Spécial:Préférences#mw-prefsection-rendering ? Wouldn't that mean that a lot of people would log in and suddenly see a completely different user interface without knowing why and not necessarily knowing how to revert (if they wanted), even those people who intentionally chose to prefer Vector over other skins? (Note that the Preferences unfortunately does not offer a "Use default skin" setting; you explicitly have to choose a skin...)

Pretty sure they're saying that everyone who hasn't selected a particular skin in preferences already would now get timeless, just they'd be able to change by going to preferences.

Yes, this is what I mean. Thank you.

Noe added a comment.EditedMar 9 2019, 10:33 AM

Not sure I'd say it's the base identity of Wiktionary/Wikipedia, but I can understand concerns about it being different between different language wikis of the same project to some extent.

Wiktionary have a diferent visual identity anyway, as the logo is diferent and the structure of the pages difers. On French Wiktionary, there is small pictures before section titles, but not on German Wiktionary or others. The skin change will not make a bigger change.

Noe added a comment.EditedMar 9 2019, 10:48 AM

I've just been avoiding this entire thing because it scares me (sorry), but if we do such a change, we do probably want to do it across all (normal) projects, and have a consensus that it's time to change the overall identity of the lot, since visual identity is a huge thing.
Even if the concerns are largely functional (such as that Vector just doesn't serve the needs of a project), it would still need to be across the entire project (all languages) to make sense, and even then probably require some wider... establishing that this is a thing we now do these days. Though I suppose if all languages of a project agreed it was needed, maybe that would be enough to get all the meta people on board... but we'd have to see it happen to really be sure. It'd at very least establish that we definitely need *some* sort of change, though.

Thank you for your analisis and opinion on this. I disagree about the strategy for a change on global Wiktionary. As a founder of the Tremendous Wiktionary User Group, I looked at the procedures of a unique logo for Wiktionaries and I think it will be the same story for a skin change.

Each Wiktionary community live their own life, with few consideration for the other project or for the Wikimedia Foundation, because no positive development was made by the WMF in the last 15 years to help this lexicographical project(note that Cognate was an improvement, but made by WM-DE not WMF). Visual editor do not fit with Wiktionaries needs, the 2030 texts do not talk about Wiktionaries, the app is not supported anymore and Internet archive bot was invited since a while without any answer.
Wiktionaries communities just try to work honestly, gather a good content and experiment changes because it is a wiki.

Changing at the level of one project may warm up other Wiktionaries or not, but the change doesn't have to be uniform. Why could it have to be?

I was the one who informed the French Wiktionary team in person, since the skin is used a lot there, that they could change the default interface if they wanted to.
From a technical point of view, I don't see any problems to implement the community consensus.

There have already been several comments on this task indicating that as a matter of principle this could not be done. Is it possible to have more information (@Jdforrester-WMF)? And the discussion from 2010 does not seem to me to be easily parallelizable here. It should also be noted that in the previous one noted by @Aklapper it was the German wikipedia, a wiki that is not comparable in terms of size.

I hear the argument of the uniqueness of wiki design. @Noe gave his opinion on this point. But is the problem to avoid losing contributors or readers? Or not to change habits of existing users? I have difficulty seeing what the problem would be in practice. Okay, the identity would be changed, but that's already the case with a logo that changes for an anniversary, as it's regularly done. And how annoying it is that the identity differ between wikis in the same language?
Couldn't we for example set up a test over for example 6 months, during which the default skin is modified as requested, and that at the end we look at the metrics (views, edits, account creation...) to see what it is? In the same way as what had been done for the deactivation of the creation of new articles by anonymous users on enwiki.
Note that contributors to other projects can since the introduction of global preferences select the preferred skin that would apply everywhere, whether Timeless is by default or not.

On a high level I'd point to https://meta.wikimedia.org/wiki/Limits_to_configuration_changes (but hard to say for me if / how much that would apply here).

You know, that is a good point about Wiktionaries being their own thing. I'd personally still prefer to see this discussed across the lot of them, but... maybe I'm also partly just saying that because I'm trying to put the whole thing off because this just scares me, too. Changing skins is a big thing, and we definitely need to be working on actually moving toward doing that, on all projects, never even mind if it's to the same skins, but are we ready? Is this skin ready?

I don't know! The wiktionary community(s) in question might, though, so maybe we should be listening, here. Since, well, they actually use the projects, and use the skins in question...

That could be a good move to see if the skin works on a whole project, if there is a solid plan to measure impact.

Noe added a comment.Mar 18 2019, 8:57 PM

Hi!

The vote is going well. Almost 30 votes, that's quite a lot for our small community. More than any previous votes.

So, could you (indefinite, I don't know who can have the power to do the change) please be ready to apply this decision, if it succeed, Thursday night or Friday.

Thank you in advance.

Hi!
The vote is going well. Almost 30 votes, that's quite a lot for our small community. More than any previous votes.
So, could you (indefinite, I don't know who can have the power to do the change) please be ready to apply this decision, if it succeed, Thursday night or Friday.
Thank you in advance.

As I said above, I don't think this request will be accepted, sorry.

Hi !
Is there any hope to see the Foundation doing something good for Wiktionnaire ? ( I mean Community wishlist survey is energy-hungry for us and without any benefits). Why developing a skin if nobody use it ?
We want to be a pilote-wiki !

We are not a small project !

Hi!
The vote is going well. Almost 30 votes, that's quite a lot for our small community. More than any previous votes.
So, could you (indefinite, I don't know who can have the power to do the change) please be ready to apply this decision, if it succeed, Thursday night or Friday.
Thank you in advance.

As I said above, I don't think this request will be accepted, sorry.

Noe added a comment.EditedMar 19 2019, 6:37 AM

That could be a good move to see if the skin works on a whole project, if there is a solid plan to measure impact.

Sorry, I skipped to answer you about impact. Thanks to Wikistats 2, we will have some measurement on the community activity. Then, French Wiktionary gathers plenty stats each months in Actualités newsletter, quite a unique journal.
Also, we have a monthly meeting in a pub in Lyon, France, for 4 years now. A dozen of people each months, with new people often. We plan to investigate with those people for feedbacks.
Plus, there is a monthly live video (Let's contribute, pretty much like a let's play video but on Wiktionnaire) and we will have feedbacks by the audience in the chat. A discord is also active and informed about this vote.

In six month from here, there is Wikiconvention francophone and it will be a proper delay to make a summary of our observations and to do a feedback to the broader community.

We could definitively use some work by an professionnal UX if one would join. But only with on our own community activities and communication routine, we are certainly able to measure the impact on contribution and reading.

@Jdforrester-WMF : could you please provide some rational?

Dcljr added a subscriber: Dcljr.Mar 19 2019, 7:19 AM

Sorry, but I just have to point out (as a "lurker" with no power to make or implement any decisions here):

There's absolutely nothing preventing every single member of the frwiktionary community from enabling the Timeless skin in their own Preferences. You can even encourage this by adding instructions on how to do it to "welcome" messages for new users and to various help pages, etc., and whatever other on-wiki solutions you want to try. It just looks like you're not going to be able to "force" this as a default applied automatically to everyone looking at the wiki. C'est la vie.....

I know that's frustrating, but it's not like you're being prevented from using the skin at all. Anyone who wants to, can use the skin on the wiki (as long as it's working).

Noe added a comment.EditedMar 19 2019, 8:19 AM

Sorry, but I just have to point out (as a "lurker" with no power to make or implement any decisions here):
There's absolutely nothing preventing every single member of the frwiktionary community from enabling the Timeless skin in their own Preferences. You can even encourage this by adding instructions on how to do it to "welcome" messages for new users and to various help pages, etc., and whatever other on-wiki solutions you want to try. It just looks like you're not going to be able to "force" this as a default applied automatically to everyone looking at the wiki. C'est la vie.....
I know that's frustrating, but it's not like you're being prevented from using the skin at all. Anyone who wants to, can use the skin on the wiki (as long as it's working).

Hi Dcljr,

Thank you for your comment. Our goal is not to make Timeless more popular but to make French Wiktionary more identifiable than it is now. During our investigation in public events or during our monthly meeting we used to asked "Have you ever found a definition on Wikipedia, with examples, synonyms and so on?", then often people agreed and we conclude "So, you already used Wiktionary!".

Having exactly the same global design deserve the recognition of Wiktionary as a separate project with a specific organization of content, rules and community.
Also, change the design for the 15th birthday of the project sounds like a clever move. We wrote some lines for the press to mention this milestone (without mentioning the skin change), but I am almost certain the reach will be limited. A nice change in design and the fact to be on the edge of modernity could create something more attractive for journalists (because they use Wiktionary a lot) and create a better coverage for our communique.

So, this proposal is, in a way, a support to Timeless because we are several people that already use it all the time, but it is mainly a strategy to enhance the notoriety of Wiktionnaire and improve the readers experience.

Vote done, decision accepted by the community. To deploy, if possible for the 22th, anniversary of French Wiktionary.

Bawolff added subscribers: ovasileva, Heather, Bawolff.EditedMar 20 2019, 9:54 PM

So this is a bit of a grey area of if this change is within the realm of things that a community can request. The foundation may feel it wants a consistent feel to all the projects that it hosts.

To that end, I think someone from the foundation needs to give an official Yes/No decision from the foundation for if the WMF is officially vetoing this change. I'm CC'ing @Heather from comms & @ovasileva from Readers Web, in the hopes of getting the ball moving.

To summarize: The issue at hand is: The french wiktionary community wants to change the default skin on fr.wiktionary.org to Timeless. This means that they want the site to look like https://fr.wiktionary.org/wiki/Wiktionnaire:Page_d%E2%80%99accueil?useskin=timeless instead of the normal vector interface for all users (except for users who opt out). Is the WMF vetoing this decision for straying to far from the normal branding of vector?

Thank you.

We are reviewing this discussion, though it is unlikely we will have a well considered response inside of 24 hours.

Noe added a comment.EditedMar 22 2019, 9:31 AM

Thank you.
We are reviewing this discussion, though it is unlikely we will have a well considered response inside of 24 hours.

Thank you for your notice. We are waiting for your approval or denial. Today is a joyful and pride day for French Wiktionarians and we published a press release to celebrate this milestone! The link include the parameter to show the page in Timeless but the text do not mention it.

Congratulations to Noe and the other French Wiktionarians on your huge birthday!!!

To folks with merge permissions, please hold-off on making any changes until we can sort out the implications. We're hoping to have a response for the French Wiktionary community by mid next week.

greg added a subscriber: greg.Mar 22 2019, 11:46 PM

Apologies for the delay in reply! We wanted to speak internally across teams before continuing the conversation. To make sure we get more eyes on this, we have posted our reply on French Wiktionary Wikidémie. We're looking forward to hearing your thoughts.

ovasileva changed the task status from Open to Stalled.Mar 28 2019, 10:49 AM

In the meantime, I'm marking this task as stalled while the conversation continues.

Noe added a comment.Mar 28 2019, 10:58 AM

The delay was totally correct, no need for apologies for it. Actually, I think you took this subject seriously and managed to discuss it quite fast, and I want to thank you for that.

Your answer is perfectly fine, despite being not what I wanted, and we will discuss it in French there.

I think it could be nice to send the original version in English to Isarra, to let her have a perfect understanding of your rational.

Cheers

Thanks @Noe and yes - that's actually a really good point - just sent @Isarra the full version in English.

@ovasileva: Could the English reply please be made public (here or somewhere else) as a reference to similar future requests and linked / documented on https://meta.wikimedia.org/wiki/Limits_to_configuration_changes ? TIA

English version she sent me:

Wikimedia Foundation response to request for skin change

Hi all, my name is Olga and I’m the product manager on the Readers web team at the Wikimedia Foundation. We’re the maintainers of the official mobile and desktop skins on Wikimedia projects. Our work is focused on large scale changes and improvements to the user experience of readers of Wikimedia content. This year, we’re also focused on improving our desktop and mobile sites to cover the needs of our editors as well.
After discussing your request to switch to the Timeless skin by default internally, we wanted to reach out with some comments. We understand that you want to celebrate your accomplishments and stand out visually from Wikipedia. In order to do that, you would like to adopt Timeless as the default skin for French Wiktionary. Unfortunately, we can not support this request.
We feel that it would be irresponsible for us to support the change knowing we do not have the resources or strategic direction to deploy or maintain Timeless in the future. Some of our reasoning can be found below and we’d be happy to answer further questions. Also, we would like to open and encourage further discussion with the French Wiktionary community on other ways we can collaborate to help the French Wiktionary satisfy the needs of its readers and editors and to celebrate the project’s big anniversary (more on this below).

'''Current and future support'''

French Wiktionary is not a small project. Supporting a skin like Timeless for all readers and editors on such a large scale is not currently feasible for us. Timeless has a single maintainer who is a volunteer developer with limited resources. Currently, the Timeless skin is used by less than 4% of active editors on French Wiktionary (19 active editors have it turned on at this time). Preparing it for significantly increased and sustained traffic raises concerns around caching, performance and service-level agreements that cannot be met without a dedicated team at the Wikimedia Foundation involved in its development. Currently the Readers web team is responsible for the default skins on Wikimedia projects (Vector and MinervaNeue). We have to prioritize our work and do not have the capacity to take on assistance or maintenance of any of the volunteer-supported skins that are available to logged-in users.

The amount of work required by the Wikimedia Foundation to support an additional skin is significant and not confined to the occasional bug-fixing. It would require attention from multiple teams across the Foundation even prior to any deployment, as well as ongoing dedicated time for maintenance:
Performance – we monitor Vector and Minerva for the impact to users experience and would need to also monitor Timeless. Currently, CSS included in the Timeless skin is higher than the Vector skin by 5kb. This is likely to lead to performance degradation for many of our users using low-bandwidth connexions. Refining and minimizing these performance losses requires additional infrastructure and staff time. If we deployed any new skin as default we would also need to perform an audit before deploying to such a large audience to monitor and respond to changes. This work should be done before any deployment, and it could not be finished by the date requested anyway.

  • Quality Assurance – We have very limited resources for quality assurance testing and would be unable to test every new feature that would be deployed to French Wiktionary using Timeless. This means we would have to ignore French Wiktionary in our future QA, which would clearly be irresponsible.
  • Security – Timeless has currently passed security review. However, as all other extensions, it might need additional review in the future based on changes to Timeless itself, or to other parts of the codebase.
  • Bug-fixing and feature requests – as mentioned above, we would need to dedicate resources for triaging and prioritising bug reports, providing maintenance patches and any feature requests to make them compatible with Timeless. Without this, in the most extreme situations, the entire French Wiktionary site might become unusable and/or unbreak-now bugs would block all deploys for all projects. Our team does not have enough staff to do this.

At this time, we don’t have a way of supporting the skin and deciding to do so would pull resources away from our current work related to the Movement Strategy focused on providing better mobile experiences for all projects, in order to support Timeless.

'''Consistency'''

The visual relationship between the Wikimedia projects is an important one, one that helps build and increase trust in the people who need our free knowledge projects. Consistency across Wikimedia sites is also important for the users. Applying a change like this could fragment the experience and affect the use of Wikimedia sites. Users switching between languages would be confused by the jarring and unexpected changes in their experiences. This could also affect Wiktionary editors working across different sites (particularly those with anonymous accounts) as they would have to learn to work across two different experiences.

'''Movement Strategy and our approach to responsive skins'''

We would like to take a moment to highlight what we are currently working on, to help everyone further understand the rationale behind our decision as well as to highlight the ways in which French Wiktionary will benefit from our current work and identify other points of collaboration.

Mobile devices are increasingly becoming the default way to interact with many Wikimedia projects, and we have made a commitment to address editing on mobile to provide a sustainable future for our projects. We have also focused on modernizing our product experiences by investing in our responsive skin, Minerva, which is the default skin on the mobile website. Over the past year, we have been focused on the [[mw:Reading/Web/Advanced_mobile_contributions|advanced mobile contribution project]] that would bring access to all special pages and an expanded set of editor tools that are more optimised for mobile users. We are also building a new navigation in the Minerva skin that is more reminiscent to the navigation of the Vector skin so that users can access all of these tools. These changes are targeted at creating an improved reading and editing experience on the mobile website and the Minerva skin overall.

Based on the conversations around the Timeless skin on French Wiktionary so far, it seems that the French Wiktionary community is also focused on tackling these issues around displaying contents related to contributions on mobile. We would love to collaborate on this. If there’s interest, we would be glad to add French Wiktionary to the list of wikis that receive these new features as they come out and are open to feedback on the results and ideas for improvement.

'''Forward together'''

Timeless remains available so that anyone with a Wikimedia account can enable in their preferences. The French Wiktionary community can make recommendations to use Timeless, but given the reasoning above, we do not recommend you do so. We do hope you reach out to us with thoughts on the Advanced mobile contributions project. Your input and feedback will help not only French Wiktionary, but all mobile contributors to the Wikimedia movement.
We are also open to receiving feedback on the brand recommendation we shared in February.[1]

We are excited for your accomplishments as a community and project. A 15 year anniversary, over 3.4 million definitions, and 20 million page views a month is worth celebrating. Beyond participating in the work around advanced mobile contributions, if you are interested in working with us to tell more people about your work you’re always, let us know and we’ll get you in touch with our Communications team to [[meta:Wikimedia_Blog|work on an article for the Wikimedia blog]]. You are also invited to present at the [[meta:Wikimedia_monthly_activities_meetings|monthly activities meeting]] to share your story with more people across the movement.

Thank you,
Olga Vasileva

[1] https://wikimediafoundation.org/2019/02/26/leading-with-wikipedia-a-brand-proposal-for-2030/--

Note that it could probably use formatting for here and I have no comments because I am ill and tired and ill and about to fall over good night.

@ovasileva: Could the English reply please be made public (here or somewhere else) as a reference to similar future requests and linked / documented on https://meta.wikimedia.org/wiki/Limits_to_configuration_changes ? TIA

Let's wait for a few days to see what other feedback we get on the page - will add to https://meta.wikimedia.org/wiki/Limits_to_configuration_changes afterwards.

Apologies for the delay in reply! We wanted to speak internally across teams before continuing the conversation. To make sure we get more eyes on this, we have posted our reply on French Wiktionary Wikidémie. We're looking forward to hearing your thoughts.

Thank you very much for taking the time to explain to the people concerned the reasons for your decision (and not just "it's not possible")!

Thank you for your detailed response.

I entirely understand your concerns that changing the default skin on a single wiki could result in brand dilution. If I was in your position, I would probably make the same call on that point.

However, I think parts of your response mischaracterize Timeless, its development process, and its current state. Given the length of your response, I hope you don't mind if I respond inline to specific claims I am concerned about.

We feel that it would be irresponsible for us to support the change knowing we do not have the resources or strategic direction to deploy or maintain Timeless in the future.

[..]

French Wiktionary is not a small project. Supporting a skin like Timeless for all readers and editors on such a large scale is not currently feasible for us.

I can fully understand being concerned that your team will be stuck maintaining something that you had no part in making. I wouldn't want to be in a position to do that for some project I wasn't involved in. However, nobody is asking that your team maintain timeless. It has its own set of maintainers who are committed to ensuring it gets the proper support. Your team should not have to be involved with maintaining this project anymore than it would be involved with maintaining any other feature that is outside of its team responsibilities.

Timeless has a single maintainer who is a volunteer developer with limited resources

Timeless is maintained by several people, not just one. The lead developer, Isarra is being financially compensated for her work, so I'm not sure if describing her as a volunteer is technically correct.

Resources are of course not infinite, but they never are. If you have specific concerns about lack of capacity in the team developing Timeless, could you be more explicit about what they are and what the necessary level of capacity would be to rectify them?

Currently, the Timeless skin is used by less than 4% of active editors on French Wiktionary (19 active editors have it turned on at this time)

Since you bring up this number, may I ask what you would consider a large enough number to rectify your concerns on this point? For me at least, I find this number very difficult to interpret. This is not a fair A/B test. Users aren't randomly selected and given timeless and asked if they like it. They have to specifically seek it out, find a fairly hidden preference, and select it. 4% may be low in absolute numbers, but it is still very high in terms of people who have taken the effort to use an alternative skin. Its not even clear to me if measuring active users is a good way to come up with a relevant number (Perhaps it should be normalized by number of edits made with timeless, which is 7% of logged in users for the last 30 day. Perhaps we should be considering people who set their preference to timeless but don't edit [There are 21 as of this writing]. I have no idea if any of these measures are better then any other, or how to interpret any of them). Statistics are like science, one really should set the goalposts (hypothesis) before making the measurement, otherwise it is very easy to interpret the results however you want.

To summarize: I don't think you can really draw any conclusion from this number due to severe selection bias other than there is above average interest in Timeless as a skin on frwiktionary. To draw a fair conclusion based on statistics we would have to do some sort of controlled testing.

Preparing it for significantly increased and sustained traffic raises concerns around caching, performance and service-level agreements that cannot be met without a dedicated team at the Wikimedia Foundation involved in its development.

Fr.wiktionary is of course an extremely successful project, and a very large wiki relatively speaking. However ultimately it only represents 0.13% of our traffic. (source: 1, 2) I don't think I would call 0.13% a "significant" increase in traffic from a technical perspective. Especially given a significant portion of that would be served by varnish.

Caching is largely speaking handled at a different layer then the skin level. Timeless, like all other major skins, uses resource loader for caching its static assets. The non-"chrome" parts of the page are of course handled by parser-cache. Last of all, most logged out users are handled by varnish cache. All of these are part of MediaWiki's general caching infrastructure and not skin-specific code.

Skins do run some code on every request that isn't handled by varnish or is a 304. It is of course important that this is performant given how often it is run. Based on some very initial testing [very low sample size], Timeless is a tiny bit slower than vector on backend latency when serving Special:BlankPage. On the other hand Timeless is faster than monobook (source: timeless, vector, monobook). I don't think the difference here is significant. I especially don't think the difference would be significant on non-trivial pages where other costs would be a higher percentage of the run time.

Is there any reason to suspect that Timeless is not up to par on caching, especially given this is mostly not something that is controlled by the skin?

On the topic of "Service level agreements". Would you be able to link to which service level agreements you are referring to? Perhaps the Timeless team is able to fulfil these agreements. Perhaps they already are.

[I'll address performance further down, with the higher CSS footprint stuff]

We have to prioritize our work and do not have the capacity to take on assistance or maintenance of any of the volunteer-supported skins that are available to logged-in users.

[..]

The amount of work required by the Wikimedia Foundation to support an additional skin is significant and not confined to the occasional bug-fixing.

As mentioned above, I don't think there is any expectation that the readers team would take this on. Timeless has its own maintainers who can handle this.

Performance we monitor Vector and Minerva for the impact to users experience and would need to also monitor

Surely adding a couple extra urls to http://wpt.wmftest.org/ and other performance testing tools is not that hard. They are after all designed to be used to test a wide variety of features developed for Wikimedia properties, not just vector and minerva.

Currently, CSS included in the Timeless skin is higher than the Vector skin by 5kb. This is likely to lead to performance degradation for many of our users using low-bandwidth connexions.

There's certainly more work to be done in performance optimizing Timeless and you are right that the CSS footprint is heavier than Vector currently. That said I think these concerns are significantly over-stated. WebPageSpeed measures Timeless as having a speed index on 2G of 0.03 seconds faster than Vector (Source: vector, timeless). This is almost certainly within measurement error of the test. Of course, synthetic testing is different than real testing, not to mention the low sample size. However I think this very clearly shows that to the first approximation, Timeless is very competitive with Vector in terms of performance for low bandwidth users.

Security

Skins are generally lower risk components than people usually assume, since they mostly do not handle user input directly. That said a security issue can happen anywhere. If indeed there was some sort of issue in Timeless, the risk wouldn't change depending on if it was the default skin or not. If hackers wanted to hack timeless (or any other available skin), they would just add ?useskin=timeless to the end of the url.

I should also note, as a general rule extensions requring re-review due to changes is extremely rare. Typically it only happens with things that tie into authentication flows or when projects are totally rewritten from the ground up.

Bug-fixing and feature requests...we would need to dedicate resources for triaging and prioritising bug reports

The readers web team should of course not be responsible for this. Timeless devs will have to be responsible for all necessary maintenance and feature requests to Timeless.

In regards to compatibility with other components. All I can say on that is that most things should be skin agnostic. Any component that is not skin agnostic makes making changes to Vector very hard, and represents significant technical debt in my mind. Eventually there will come a day when vector needs to change something to adapt to whatever the circumstances of the day are. In my opinion it is better to find out what things changes in vector will break from the get-go instead of finding this out 5 years later when the people who worked on the component have all moved on to other things.

94rain added a subscriber: 94rain.Apr 11 2019, 4:46 AM
ovasileva closed this task as Resolved.Apr 12 2019, 3:57 PM
ovasileva claimed this task.

Thank you for raising these concerns and for the conversation. I’m resolving this task. For now, we will not be moving forward with a deployment of Timeless as a default skin on French Wiktionary. I’d like to highlight that this decision refers to setting Timeless as the default skin only and the maintenance and consistency taxes that would be associated with that. We want to be clear that we are not discouraging individuals from using Timeless or from encouraging others to do so and believe that the skin has the support necessary in this capacity. We also encourage contributors to follow the ongoing work on improving access to contributor tools on mobile within the advanced mobile contributions project. (https://www.mediawiki.org/wiki/Reading/Web/Advanced_mobile_contributions)

Pamputt changed the task status from Resolved to Declined.Apr 12 2019, 4:33 PM

To be clear: there should be minimal extra maintenance overhead to you or your team. You should be supporting all deployed skins regardless, at least as far as not breaking anything is concerned, but things happen from time to time regardless. There have been deployments that have broken default production skins in the past (last year, as I recall, Nostalgia broke to the point that all anyone got was a blank page for a bit, for instance), and these have been resolved same as any other breaking change. I don't know if the same people who broke it fixed it; doesn't really matter. We have a lot of people who care about the stability of all our sites keeping track of this, both on the job and contributing as volunteers.

Anyway, no arguments about the actual decision, just want to be clear on this specific point.